   1 REM Noughts & Crosses      
      by Mark Pickford          
    from Sinclair User, Mar'87  
Noughts and Crosses is an extre-
mely simple example of basic    
artificial intelligence. Type it
in and try to beat the computer 
at its own game. Full instruct- 
ions are enclosed in the program
         ***********************
   2 REM *                     *
   3 REM * NOUGHTS AND CROSSES *
   4 REM * MARK PICKFORD 1986  *
   5 REM *                     *
   6 REM ***********************
  10 RANDOMIZE 
  15 POKE 23609,35
  20 DIM b(3):DIM c(3)
  30 FOR f=1 TO 3:READ b(f):NEXT f
  40 FOR f=1 TO 3:READ c(f):NEXT f
  80 DATA 54,98,142
  90 DATA 35,77,122
  95 GO SUB 6000
  97 CLS
 100 GO SUB 8000:REM GRID
 990 DIM a(3,3):DIM l(8)
1000 INPUT "CO-ORDINATES";x,y
1010 IF x<1 OR x>3 OR x<>INT x OR y<1 OR y>3 OR y<>INT y THEN 
       PRINT AT 21,3;"OUT OF RANGE TRY AGAIN":GO TO 1000
1015 IF a(x,y)>0 THEN 
       PRINT AT 21,3;"POSITION FILLED":GO TO 1000
1017 PRINT AT 21,3;"                      "
1020 LET x$="X":LET sc=1
1030 IF x$="X" THEN 
       PLOT b(x),c(y):DRAW INK 2;35,35:PLOT b(x)+35,c(y):DRAW 
       INK 2;-35,35:GO TO 1040
1035 CIRCLE INK 0;b(x)+17,c(y)+17,17
1040 LET a(x,y)=sc
1050 LET l(x)=l(x)+sc
1060 LET l(y+3)=l(y+3)+sc
1070 IF x=y THEN 
       LET l(7)=l(7)+sc
1080 IF x+y=4 THEN 
       LET l(8)=l(8)+sc
1085 IF RND>.5 THEN 
       LET r1=8:LET r2=1:LET r3=-1:GO TO 1090
1086 LET r1=1:LET r2=8:LET r3=1
1090 FOR z=r1 TO r2 STEP r3
1100 IF sc=1 AND l(z)=3 THEN 
       GO TO 9010
1101 IF sc=10 AND l(z)=30 THEN 
       GO TO 5000
1110 NEXT z
1115 IF sc=10 THEN 
       GO TO 1000
1120 REM COMPUTER'S GO
1125 RESTORE 1137
1130 LET sc=10:LET x$="O"
1135 FOR w=1 TO 4
1136 READ q
1137 DATA 20,2,10,1
1138 LET r=RND
1139 IF r>.5 THEN 
       LET r1=8:LET r2=1:LET r3=-1:GO TO 1143
1140 LET r1=1:LET r2=8:LET r3=1
1143 FOR z=r1 TO r2 STEP r3
1150 IF l(z)=q THEN 
       GO TO 1170
1160 NEXT z
1161 NEXT w
1162 PRINT AT 19,1;"STALEMATE":GO TO 9110
1170 IF z>3 THEN 
       GO TO 1200
1180 IF RND>.5 THEN 
       FOR w=1 TO 3:GO TO 1190
1185 FOR w=3 TO 1 STEP -1
1190 IF a(z,w)=0 THEN 
       LET x=z:LET y=w:GO TO 1030
1195 NEXT w
1200 IF z>6 THEN 
       GO TO 1240
1210 FOR w=1 TO 3
1220 IF a(w,z-3)=0 THEN 
       LET x=w:LET y=z-3:GO TO 1030
1230 NEXT w
1240 IF z=8 THEN 
       GO TO 1280
1250 FOR w=1 TO 3
1260 IF a(w,w)=0 THEN 
       LET x=w:LET y=w:GO TO 1030
1270 NEXT w
1280 FOR w=1 TO 3
1285 IF a(w,4-w)=0 THEN 
       LET x=w:LET y=4-w:GO TO 1030
1290 NEXT w
4999 STOP
5000 REM COMP WIN
5010 PRINT AT 2,2;"HA HA THE COMPUTER WON":GO TO 9110
6000 REM INSTRUCTIONS
6010 INK 1:PAPER 6:BORDER 6:CLS:PRINT AT 2,2;"NOUGHTS AND CROSSE
     S ";AT 3,2;"                           ";AT 5,2;"          
     MARK PICKFORD 1986"
6020 PRINT AT 7,2;"DO YOU REQUIRE INSTRUCTIONS?";AT 8,2;"(Y OR N
     )":PAUSE 0:IF INKEY$="N" OR INKEY$="n" THEN 
       RETURN
6030 PRINT AT 7,2;"                                             
      "
6040 PRINT AT 7,2;"This is the computer version    of Noughts an
     d Crosses."
6050 PRINT AT 9,2;"You are CROSSES.";AT 10,2;"You have to get a 
     line ";AT 12,4;"diagonally";AT 13,4;"horizontally";AT 14,1;
     "or vertically"
6060 PRINT AT 16,2;"The first person (YOU or FRED)";AT 17,2;"to 
     do this wins";AT 18,2;"P.S. FRED is the computer"
6070 PRINT AT 19,2;"You type the co-ordinates of";AT 20,2;"where
      you want to go"
6080 PRINT AT 21,2;"Press any key to start":PAUSE 0:RETURN
8000 REM GRID
8010 PLOT 50,30:DRAW 0,132:DRAW 132,0:DRAW 0,-132:DRAW -132,0
8015 BEEP .5,1
8020 DRAW 0,44:DRAW 132,0:DRAW 0,44:DRAW -132,0
8025 BEEP .5,3
8030 DRAW 0,44:DRAW 44,0:DRAW 0,-132
8035 BEEP .5,5
8040 DRAW 44,0:DRAW 0,132
8045 BEEP .5,6
8050 PRINT AT 20,8;"1";AT 20,14;"2";AT 20,20;"3"
8060 PRINT AT 4,4;"3";AT 9,4;"2";AT 14,4;"1"
9000 RETURN
9010 FOR g=1 TO 2
9015 PAUSE 40
9020 BEEP .2,1:BEEP .2,3:BEEP .2,5:BEEP .3,6:BEEP .3,1
9025 PAUSE 5
9030 BEEP .2,6:BEEP .2,5:BEEP .2,6:BEEP .3,8:BEEP .4,3
9035 PAUSE 5
9040 BEEP .2,3:BEEP .2,5:BEEP .2,6:BEEP .2,10
9050 BEEP .2,8:BEEP .2,8:BEEP .2,6:BEEP .2,6:BEEP .2,5
9060 BEEP .2,3:BEEP .2,5
9065 IF g=1 THEN 
       BEEP .2,1
9070 NEXT g
9080 BEEP .2,6
9090 CLS:PRINT AT 2,2;"              "
9100 PRINT AT 8,2;INK 2;"                                       
                  "
9110 PRINT AT 20,1;"DO YOU WANT ANOTHER GO?(Y OR N)":PAUSE 0:IF 
     INKEY$="Y" OR INKEY$="y" THEN 
       RUN 
9120 BEEP 1,1:LIST 
** END OF FILE **
